Attribute VB_Name = "M6502AddrModes"
Option Explicit

DefLng A-Z

' M6502 CPU Implementation for basicNES.
' By Don Jarrett and Tobias Strmstedt, 1997-2003.
' If you use this file commercially please drop a mail
' at r.jarrett@worldnet.att.net or d.jarrett@worldnet.att.net.
' YoshiNES Copyright (C) 1996-2002 Don Jarrett.

Public CurrentLine As Long 'Integer

'Registers and tempregisters
'DF: Be careful. Anything, anywhere that uses a variable of the same name without declaring it will be using these:
Public a As Byte
Public x As Byte
Public y As Byte
Public s As Byte
Public P As Byte

'32bit instructions are faster in protected mode than 16bit
Public PC As Long
Public savepc As Long
Public Value As Long 'Integer
Public value2 As Long 'Integer
Public sum As Long 'Integer
Public saveflags As Long 'Integer
Public help As Long

Public opcode As Byte
Public clockticks6502 As Long

' arrays
Public Ticks(0 To &H100&) As Byte
Public addrmode(0 To &H100&) As Byte
Public instruction(0 To &H100&) As Byte
Public GameImage() As Byte

Public maxIdle As Long

Public CPUPaused As Boolean

Public addrmodeBase As Long

Public maxCycles1 As Long 'max cycles per scanline from scanlines 0-239
Public maxCycles As Long 'max cycles until next scanline
Public SmartExec As Boolean
Public realframes As Long 'actual # of frames rendered

Public IdleDetect As Boolean
'Private IdleAddr As Long
Public idleCheck(65535) As Byte

Public AutoSpeed As Boolean

Public KeyCodes(7) As Long

Public rCycles As Long 'real number of cycles executed
Public nCycles As Long 'number that should be executed
Public SaveCPU As Boolean ' Pause CPU when YoshiNES loses focus?

Public Const M6502_INTERNAL_REVISION = "v.18"
Public Sub indabsx6502()
    help = Read6502(PC) + (Read6502(PC + 1) * &H100&) + x
    savepc = Read6502(help) + (Read6502(help + 1) * &H100&)
End Sub
Public Sub indx6502()
    'TS: Changed PC++ and removed ' (?)
      Value = Read6502(PC) And &HFF
      Value = (Value + x) And &HFF
      PC = PC + 1
      savepc = Read6502(Value) + (Read6502(Value + 1) * &H100&)
End Sub
Public Sub indy6502()
    'TS: Changed PC++ and == to != (If then else)
      Value = Read6502(PC)
      PC = PC + 1
          
      savepc = Read6502(Value) + (Read6502(Value + 1) * &H100&)
      If (Ticks(opcode) = 5) Then
        If ((savepc \ &H100&) = ((savepc + y) \ &H100&)) Then
        Else
          clockticks6502 = clockticks6502 + 1
        End If
      End If
      savepc = savepc + y
End Sub
Public Sub zpx6502()
    'TS: Rewrote everything!
    'Overflow stupid check
    savepc = Read6502(PC)
    savepc = savepc + x
    PC = PC + 1
    savepc = savepc And &HFF
End Sub
Public Sub exec6502()
    Dim f As Long
    f = Frames
    While CPUPaused
        DoEvents
    Wend
    While Frames = f And CPURunning
        opcode = Read6502(PC)  ' Fetch Next Operation
        PC = PC + 1
        If IdleDetect Then
            If idleCheck(PC) > 8 Then
                If CurrentLine > 240 Or CurrentLine < maxIdle Then
                    idleCheck(PC) = idleCheck(PC) - 8
                Else
                    clockticks6502 = clockticks6502 + CurrentLine \ 2: rCycles = rCycles - CurrentLine \ 2
                End If
            End If
            If CurrentLine >= 231 And CurrentLine < 238 And idleCheck(PC) < 240 Then
                idleCheck(PC) = idleCheck(PC) + 1
            End If
        End If
    
        clockticks6502 = clockticks6502 + Ticks(opcode)
    
        Select Case instruction(opcode)
                Case INS_JMP: ' jmp6502
                    adrmode opcode
                    PC = savepc
                Case INS_LDA: ' lda6502
                    adrmode opcode
                    a = Read6502(savepc)
                    SetFlags a
                Case INS_LDX:
                    adrmode (opcode)
                    x = Read6502(savepc)
                    SetFlags x
                Case INS_LDY
                    adrmode (opcode)
                    y = Read6502(savepc)
                    SetFlags y
                Case INS_BNE: bne6502
                Case INS_CMP: cmp6502
                Case INS_STA
                    adrmode (opcode)
                    Write6502 savepc, a
                Case INS_BIT: bit6502
                Case INS_BVC: bvc6502
                Case INS_BEQ: beq6502
                Case INS_INY: iny6502
                Case INS_BPL: bpl6502
                Case INS_DEX: dex6502
                Case INS_INC: inc6502
                Case INS_DEC: dec6502
                Case INS_JSR: jsr6502
                Case INS_AND: and6502
                Case INS_NOP:
                
                Case INS_BRK: brk6502
                Case INS_ADC: adc6502
                Case INS_EOR: eor6502
                Case INS_ASL: asl6502
                Case INS_ASLA: asla6502
                Case INS_BCC: bcc6502
                Case INS_BCS: bcs6502
                Case INS_BMI: bmi6502
                Case INS_BVS: bvs6502
                Case INS_CLC: P = P And &HFE
                Case INS_CLD: P = P And &HF7
                Case INS_CLI: P = P And &HFB
                Case INS_CLV: P = P And &HBF
                Case INS_CPX: cpx6502
                Case INS_CPY: cpy6502
                Case INS_DEA: dea6502
                Case INS_DEY: dey6502
                Case INS_INA: ina6502
                Case INS_INX: inx6502
                Case INS_LSR: lsr6502
                Case INS_LSRA: lsra6502
                Case INS_ORA
                    adrmode opcode
                    a = a Or Read6502(savepc)
                    SetFlags a
                Case INS_PHA: pha6502
                Case INS_PHX: phx6502
                Case INS_PHP: php6502
                Case INS_PHY: phy6502
                Case INS_PLA: pla6502
                Case INS_PLP: plp6502
                Case INS_PLX: plx6502
                Case INS_PLY: ply6502
                Case INS_ROL: rol6502
                Case INS_ROLA: rola6502
                Case INS_ROR: ror6502
                Case INS_RORA: rora6502
                Case INS_RTI: rti6502
                Case INS_RTS: rts6502
                Case INS_SBC: sbc6502
                Case INS_SEC: P = P Or &H1
                Case INS_SED: P = P Or &H8
                Case INS_SEI: P = P Or &H4
                Case INS_STX
                    adrmode (opcode)
                    Write6502 savepc, x
                Case INS_STY
                    adrmode (opcode)
                    Write6502 savepc, y
                Case INS_TAX: tax6502
                Case INS_TAY: tay6502
                Case INS_TXA: txa6502
                Case INS_TYA: tya6502
                Case INS_TXS: txs6502
                Case INS_TSX: tsx6502
                Case INS_BRA: bra6502
                Case Else: MsgBox "Opcode invlido - " & Hex$(opcode)
        End Select
      
        If clockticks6502 > maxCycles Then
            nCycles = nCycles + 114
            rCycles = rCycles + maxCycles
            Select Case Mapper
                Case 4, 47, 118, 115, 95, 151, 12, 64, 158, 74, 245: map4_hblank CurrentLine, PPU_Control2
                Case 6: map6_hblank CurrentLine
                Case 16: map16_irq
                Case 17: map17_doirq
                Case 19, 184, 87, 86, 79, 113: map19_irq
                Case 23: map23_irq
                Case 24, 26: map24_irq
                Case 40, 61, 200: map40_irq
                Case 85: map85_irq
                Case 117: map117_hblank CurrentLine
            End Select
            RenderScanline CurrentLine
            If CurrentLine >= 240 Then
                If CurrentLine = 240 Then
                    If render Then blitScreen
                    Frames = Frames + 1
                    If render Then realframes = realframes + 1
                    DoEvents 'ensure most recent keyboard input
                    
                    'hold down 'a' key for autofire. now 15hz, not 30
                    
                    'The code is broken be now
                    'You can fix it or wait the next release
                    
                    If Keyboard(65) <> &H41 Then
                        Joypad1(0) = Keyboard(nes_ButA) 'A
                        Joypad1(1) = Keyboard(nes_ButB) 'B
                    ElseIf Frames And 2 Then
                        Joypad1(0) = Keyboard(nes_ButA) 'A
                        Joypad1(1) = &H40
                    Else
                        Joypad1(0) = &H40
                        Joypad1(1) = Keyboard(nes_ButB) 'B
                    End If
                        
                    Joypad1(2) = Keyboard(nes_ButSel) 'Sl
                    Joypad1(3) = Keyboard(nes_ButSta)
                    Joypad1(4) = Keyboard(nes_ButUp)
                    Joypad1(5) = Keyboard(nes_ButDn)
                    Joypad1(6) = Keyboard(nes_ButLt)
                    Joypad1(7) = Keyboard(nes_ButRt)
                    
                    If Keyboard(65) <> &H41 Then
                        Joypad2(0) = Keyboard(nes2_ButA) 'A
                        Joypad2(1) = Keyboard(nes2_ButB) 'B
                    ElseIf Frames And 2 Then
                        Joypad2(0) = Keyboard(nes2_ButA) 'A
                        Joypad2(1) = &H40
                    Else
                        Joypad2(0) = &H40
                        Joypad2(1) = Keyboard(nes2_ButB) 'B
                    End If
                        
                    Joypad2(2) = Keyboard(nes2_ButSel) 'Sl
                    Joypad2(3) = Keyboard(nes2_ButSta)
                    Joypad2(4) = Keyboard(nes2_ButUp)
                    Joypad2(5) = Keyboard(nes2_ButDn)
                    Joypad2(6) = Keyboard(nes2_ButLt)
                    Joypad2(7) = Keyboard(nes2_ButRt)
                    
                    If Record = True Then
                        Put #1, , Joypad1
                        Put #1, , Joypad2
                    ElseIf Playing = True Then
                        Get #1, , Joypad1
                        Get #1, , Joypad2
                        If EOF(1) Then
                            StopPlaying
                            frmNES.mnuPlayMovie.Caption = "&Tocar"
                            Playing = False
                        End If
                    End If
                End If
                PPU_Status = &H80
                If CurrentLine = 240 Then
                    If (PPU_Control1 And &H80) Then
                        If IdleDetect Then idleCheck(PC) = 1
                        nmi6502
                    End If
                End If
            End If
            
            If CurrentLine = 0 Or CurrentLine = 131 Then UpdateSounds
            If CurrentLine = 258 Then PPU_Status = &H0
    
            If CurrentLine = 262 Then
                If maxIdle < 240 And Not SpritesChanged Then
                    maxIdle = maxIdle + 16
                Else
                    If maxIdle > 8 Then maxIdle = maxIdle - 8
                    SpritesChanged = False
                End If
                CurrentLine = 0
                
                ' ****Limit the frames to game don't run too fast****
                
                If Keyboard(192) And 1 Then
                    render = (Frames Mod 3) = 0
                Else
                    If AutoSpeed Then
                        Dim Delay As Long
                        Static Tmr As Double
                        Static PTime As Double
                        Static Facc As Double
                        Static PFrame As Long
                        Dim Tme As Double
                        
                        Tme = Timer
                        If Tme - PTime < 0.2 And PTime < Tme Then Tmr = Tmr - Tme + PTime
                        Tmr = Tmr + 0.01667 'PAL or NTSC 50 or 60 fps
                        PTime = Tme
                        render = True
                        
                        If Tmr > 0 Then Delay = 10000 * Tmr * Tmr: Sleep (Delay)
                    End If
                    render = (Frames Mod FrameSkip = 0)
                End If
                PPU_Status = &H0
            Else
                CurrentLine = CurrentLine + 1
            End If
            clockticks6502 = clockticks6502 - maxCycles
            If Not SmartExec Then
                If CurrentLine < 218 Or maxCycles1 > 114 Then
                    maxCycles = maxCycles1
                Else
                    maxCycles = 114
                End If
            End If
      End If
    Wend
End Sub
Public Sub SetFlags(ByVal Value As Byte)
    If (Value) Then
        P = P And &HFD
    Else
        P = P Or &H2
    End If
    If (Value And &H80) Then
        P = P Or &H80
    Else
        P = P And &H7F
    End If
End Sub
Public Sub indzp6502()
    Value = Read6502(PC)
    PC = PC + 1
    savepc = Read6502(Value) + (Read6502(Value + 1) * &H100&)
End Sub
Public Sub zpy6502()
    savepc = Read6502(PC)
    savepc = savepc + y
    PC = PC + 1
End Sub
Public Sub absy6502()
    'TS: Changed to != instead of == (Look at absx for more details)
    savepc = Read6502(PC) + (Read6502(PC + 1) * &H100&)
    PC = PC + 2
    If (Ticks(opcode) = 4) Then
        If ((savepc \ &H100&) = ((savepc + y) \ &H100&)) Then
        Else
            clockticks6502 = clockticks6502 + 1
        End If
    End If
    savepc = savepc + y
End Sub
Public Sub immediate6502()
    savepc = PC
    PC = PC + 1
End Sub
Public Sub indirect6502()
    help = Read6502(PC) + (Read6502(PC + 1) * &H100&)
    savepc = Read6502(help) + (Read6502(help + 1) * &H100&)
    PC = PC + 2
End Sub
Public Sub absx6502()
    'TS: Changed to if then else instead of if then (!= instead of ==)
    savepc = Read6502(PC)
    savepc = savepc + (Read6502(PC + 1) * &H100&)
    PC = PC + 2
    If (Ticks(opcode) = 4) Then
        If ((savepc \ &H100&) = ((savepc + x) \ &H100&)) Then
        Else
            clockticks6502 = clockticks6502 + 1
        End If
    End If
    savepc = savepc + x
End Sub
Public Sub abs6502()
    savepc = Read6502(PC) + (Read6502(PC + 1) * &H100&)
    PC = PC + 2
End Sub
Public Sub relative6502()
    'Changed to PC++ and == to != (If then else)
  
    savepc = Read6502(PC)
    PC = PC + 1

    If (savepc And &H80) Then savepc = (savepc - &H100&)
End Sub
Public Sub reset6502()
    Dim i As Long
    For i = 0 To 65535
        idleCheck(i) = 0
    Next i

    a = 0: x = 0: y = 0: P = &H20
    s = &HFF
      
    PC = Read6502(&HFFFC&) + (Read6502(&HFFFD&) * &H100&)
    Debug.Print "Reset to $" & Hex$(PC) & "[" & PC & "]"
End Sub
Public Sub zp6502()
    savepc = Read6502(PC)
    PC = PC + 1
End Sub
Public Sub irq6502()
    ' Maskable interrupt
    If (P And &H4) = 0 Then
        Write6502 &H100& + s, (PC \ &H100&)
        s = (s - 1) And &HFF
        Write6502 &H100& + s, (PC And &HFF)
        s = (s - 1) And &HFF
        Write6502 &H100& + s, P
        s = (s - 1) And &HFF
        P = P Or &H4
        PC = Read6502(&HFFFE&) + (Read6502(&HFFFF&) * &H100&)
        clockticks6502 = clockticks6502 + 7
    End If
End Sub
Public Sub nmi6502()
    On Error GoTo ErrH
    Write6502 (s + &H100&), (PC \ &H100&)
    s = (s - 1) And &HFF
    Write6502 (s + &H100&), (PC And &HFF)
    s = (s - 1) And &HFF
    Write6502 (s + &H100&), P
    P = P Or &H4
    s = (s - 1) And &HFF
    PC = Read6502(&HFFFA&) + (Read6502(&HFFFB&) * &H100&)
    clockticks6502 = clockticks6502 + 7
ErrH:
End Sub
